# See Altera "Component Interface Tcl Reference" for guide to properties

package require -exact sopc 11.0

# Module PushButtons
# ------------------
set_module_property NAME PushButtons
set_module_property VERSION 1.0
set_module_property INTERNAL false
set_module_property OPAQUE_ADDRESS_MAP true
set_module_property GROUP Peripherals
set_module_property DESCRIPTION "Push button debouncer with interrupt controls"
set_module_property DISPLAY_NAME "Push Buttons"
set_module_property TOP_LEVEL_HDL_FILE PushButtons.vhdl
set_module_property TOP_LEVEL_HDL_MODULE PushButtons
set_module_property INSTANTIATE_IN_SYSTEM_MODULE true
set_module_property EDITABLE true
set_module_property ANALYZE_HDL TRUE
set_module_property STATIC_TOP_LEVEL_MODULE_NAME PushButtons
set_module_property FIX_110_VIP_PATH false


# Files
# -----
add_file PushButtons.vhdl SYNTHESIS


# Parameters
# ---------- 
add_parameter CLOCK_RATE INTEGER 50000000
set_parameter_property CLOCK_RATE DEFAULT_VALUE 50000000
set_parameter_property CLOCK_RATE DISPLAY_NAME "Clock Rate"
set_parameter_property CLOCK_RATE TYPE INTEGER
set_parameter_property CLOCK_RATE UNITS "Hertz"
set_parameter_property CLOCK_RATE ALLOWED_RANGES 1:2147483647
set_parameter_property CLOCK_RATE AFFECTS_GENERATION false
set_parameter_property CLOCK_RATE HDL_PARAMETER true
set_parameter_property CLOCK_RATE SYSTEM_INFO_TYPE CLOCK_RATE
set_parameter_property CLOCK_RATE SYSTEM_INFO_ARG clk
add_parameter ACTIVE_HIGH INTEGER 0
set_parameter_property ACTIVE_HIGH DEFAULT_VALUE 0
set_parameter_property ACTIVE_HIGH DISPLAY_NAME "Active High"
set_parameter_property ACTIVE_HIGH TYPE INTEGER
set_parameter_property ACTIVE_HIGH UNITS None
set_parameter_property ACTIVE_HIGH DISPLAY_HINT boolean
set_parameter_property ACTIVE_HIGH ALLOWED_RANGES 0:1
set_parameter_property ACTIVE_HIGH AFFECTS_GENERATION false
set_parameter_property ACTIVE_HIGH HDL_PARAMETER true
add_parameter NUM_SWITCHES POSITIVE 4
set_parameter_property NUM_SWITCHES DEFAULT_VALUE 4
set_parameter_property NUM_SWITCHES DISPLAY_NAME "Number of buttons"
set_parameter_property NUM_SWITCHES TYPE POSITIVE
set_parameter_property NUM_SWITCHES UNITS None
set_parameter_property NUM_SWITCHES ALLOWED_RANGES 1:32
set_parameter_property NUM_SWITCHES AFFECTS_GENERATION false
set_parameter_property NUM_SWITCHES HDL_PARAMETER true


# Connection point clk
# --------------------
add_interface clk clock end
set_interface_property clk clockRate 0
set_interface_property clk ENABLED true
add_interface_port clk clk clk Input 1


# Connection point reset
# ----------------------
add_interface reset reset end
set_interface_property reset associatedClock clk
set_interface_property reset synchronousEdges DEASSERT
set_interface_property reset ENABLED true
add_interface_port reset reset reset Input 1


# Connection point avalon_slave
# -----------------------------
add_interface avalon_slave avalon end
set_interface_property avalon_slave addressUnits WORDS
set_interface_property avalon_slave associatedClock clk
set_interface_property avalon_slave associatedReset reset
set_interface_property avalon_slave bitsPerSymbol 8
set_interface_property avalon_slave burstOnBurstBoundariesOnly false
set_interface_property avalon_slave burstcountUnits WORDS
set_interface_property avalon_slave explicitAddressSpan 0
set_interface_property avalon_slave holdTime 0
set_interface_property avalon_slave linewrapBursts false
set_interface_property avalon_slave maximumPendingReadTransactions 0
set_interface_property avalon_slave readLatency 0
set_interface_property avalon_slave readWaitTime 1
set_interface_property avalon_slave setupTime 0
set_interface_property avalon_slave timingUnits Cycles
set_interface_property avalon_slave writeWaitTime 0

set_interface_property avalon_slave ENABLED true

add_interface_port avalon_slave address address Input 2
add_interface_port avalon_slave readdata readdata Output 32
add_interface_port avalon_slave read read Input 1
add_interface_port avalon_slave writedata writedata Input 32
add_interface_port avalon_slave write write Input 1


# Connection point buttons
# ------------------------
add_interface buttons conduit end
set_interface_property buttons ENABLED true
add_interface_port buttons buttons export Input num_buttons


# Connection point interrupt_sender
# ---------------------------------
add_interface interrupt_sender interrupt end
set_interface_property interrupt_sender associatedAddressablePoint avalon_slave_0
set_interface_property interrupt_sender associatedClock clk
set_interface_property interrupt_sender associatedReset reset
set_interface_property interrupt_sender ENABLED true
add_interface_port interrupt_sender irq irq Output 1