#ifndef __PUSH_BUTTONS_REGS_H__
#define __PUSH_BUTTONS_REGS_H__

#include <io.h>

// Read Registers
#define PUSH_BUTTONS_IRQ_REG								0
#define IOADDR_PUSH_BUTTON_IRQ_REG(base)				__IO_CALC_ADDRESS_NATIVE(base, PUSH_BUTTONS_IRQ_REG)
#define IORD_PUSH_BUTTONS_IRQ(base)						IORD(base, PUSH_BUTTONS_IRQ_REG)

#define PUSH_BUTTONS_STATE_REG							1
#define IOADDR_PUSH_BUTTON_STATE_REG(base)			__IO_CALC_ADDRESS_NATIVE(base, PUSH_BUTTONS_STATE_REG)
#define IORD_PUSH_BUTTONS_STATE(base)					IORD(base, PUSH_BUTTONS_STATE_REG)

// Write Registers
#define PUSH_BUTTONS_IRQ_CLEAR_REG						0
#define IOADDR_PUSH_BUTTON_IRQ_CLEAR_REG(base)		__IO_CALC_ADDRESS_NATIVE(base, PUSH_BUTTONS_IRQ_CLEAR_REG)
#define IOWR_PUSH_BUTTONS_IRQ_CLEAR(base, data)		IOWR(base, PUSH_BUTTONS_IRQ_CLEAR_REG, data)

#define PUSH_BUTTONS_IRQ_ENABLE_REG						1
#define IOADDR_PUSH_BUTTON_IRQ_ENABLE_REG(base)		__IO_CALC_ADDRESS_NATIVE(base, PUSH_BUTTONS_IRQ_ENABLE_REG)
#define IOWR_PUSH_BUTTONS_IRQ_ENABLE(base, data)	IOWR(base, PUSH_BUTTONS_IRQ_ENABLE_REG, data)

#endif